const electron = require('electron');
var fs = require('fs');
var fs_extra = require('fs-extra');
const Promise=require('bluebird');
const path = require('path');
var sqlite3 = require('sqlite3').verbose();
var http = require("request");
const EventLog= require(path.join(__dirname, 'EventLog.js'));
var db = null;
var tmp_file=path.join(electron.app.getAppPath(), 'backend', 'database', 'wsdb.db');
var db_version_file=path.join(electron.app.getAppPath(), 'backend', 'database','scripts','version.txt');
var file = path.join(electron.app.getPath("appData"), 'tiger', 'database', 'wsdb.db');
var blocked_tables={for_get:"'sqlite_sequence','reservation','db_lock','db_version'",for_post:"'reservation','updatetime'"};
const url = require('url');
let mainWindow;
let frontend_dir;
var sync_active=false;
var insert_active=false;
var db_locked=false;
var transactions=[];
var device_insert_enabled=false;
module.exports =
{
    setSyncActive:function(value)
    {
        sync_active=value;
    },
    getSyncActive:function()
    {
        return sync_active;
    },
    setMainWindow:async function(win,dir)
    {
        mainWindow=win;
        frontend_dir=dir;
        await copyDbToUserDir();
        await clearAdminDb(null,false);
    },
    getUser:function(request,responze)
    {
        mainWindow.webContents.executeJavaScript('localStorage.getItem("email")').then(function(value){
            writeResultToResponse(responze,{user:value});
        });
    },
    getDataService: async function (responze,write_to_responze=true) 
    {
        try
        {
            await lockDb();
            var result=await getAllDataFromDb();
            if(write_to_responze==true)
            {
                await unlockDb();
                writeResultToResponse(responze,result);
            }
            else
            {
                await unlockDb();
                return result;
            }
        }
        catch(ex)
        {
            await unlockDb();
            EventLog.writeLog(JSON.stringify(ex)+" LINE 37","Error");
            writeResultToResponse(responze,ex);
        }
        
    },
    postDataService:async function (responze,params) 
    {
        try
        {
            sync_active=true;
            await lockDb();
            await insertAllDataToDb(params,true);
            await unlockDb();
            sync_active=false;
            writeResultToResponse(responze,await getAllDataFromDb());
        }
        catch(ex)
        {
            await unlockDb();
            EventLog.writeLog(JSON.stringify(ex)+" LINE 51","Error");
            writeResultToResponse(responze,ex);
        }   
    },
    insertDevicesToDb:async function(_devices)
    {

        if(sync_active==false && insert_active==false && device_insert_enabled==true)
        {
            var devices=JSON.parse(_devices);
            if(devices && devices.length>0 && await checkDbLocked()==false)
            {
                insert_active=true;
               
                var new_data_action=false;
                for(var i=0;i<devices.length;i++)
                {
                    transactions=[];
                    var tmp_action=await modifyDeviceDataFromTablet(devices[i],new_data_action);
                    if(tmp_action==true)
                    {
                        new_data_action=tmp_action;
                    }
                    await runTransaction(transactions);
                }
                await checkDevicesPreferenceExist();
                for(var i=0;i<devices.length;i++)
                {
                    await modifyUpdateTime(devices[i]);
                }
                if(new_data_action==true)
                {
                    var result=await getAllDataFromDb();
                    mainWindow.webContents.send("data_sync",result);
                }
                else
                {
                    mainWindow.webContents.send("data_sync",{action:false});
                }
                insert_active=false;
            }
            else if(!devices || devices.length==0)
            {
                mainWindow.webContents.send("data_sync",{action:false});
            }
            else if(await checkDbLocked()==true)
            {
                EventLog.writeLog("DB locked because save in process");
            }
        }
        else if(insert_active==false)
        {
            mainWindow.webContents.send("data_sync",{action:false});
        }
        var stored_devices=await selectFromDb("Select * from device");
        if(stored_devices.length>0)
        {
            checkDeviceState(stored_devices,0);
        }
        
       
    },
    lockApp:async function(ip,responze,port)
    {
        http.get("http://"+ip+":"+port+"/getUser",{ timeout: 10000 }, (error, resp, body) => 
        {
            if (error || resp.statusCode == 500 || resp.statusCode == 404) 
            {
                mainWindow.webContents.send("lock",{lock:true,user:null});
                writeResultToResponse(responze,{msg:"OK"});
            }
            else if (resp && body) 
            {
                var user=JSON.parse(body);
               
                if(user.user && user.user!="null")
                {
                    mainWindow.webContents.send("lock",{lock:true,user:user.user});
                }
                else
                {
                    mainWindow.webContents.send("lock",{lock:false});
                }
                
                writeResultToResponse(responze,{msg:"OK"});
            }
           
        });
       
       
    },
    unlockApp:async function(responze)
    {
        mainWindow.webContents.send("lock",{lock:false});
        writeResultToResponse(responze,{msg:"OK"});
      
    },
    checkDbLocked: async function()
    {
        return await checkDbLocked();
    },
    clearAdminDb:async function(responze)
    {
        return await clearAdminDb(responze);
    },
    sendNewAdminAppUpdateNotification(param)
    {
        mainWindow.webContents.send("new_admin_app",param);
        EventLog.writeLog(JSON.stringify(param));
    },
    setdeviceInsertnabled:function(value)
    {
        device_insert_enabled=value;
    },
    getdeviceInsertnabled:function()
    {
        return device_insert_enabled;
    }
}
async function clearAdminDb(responze,write_resp=true)
{

        if( await checkDbLocked()==false)
        {
            sync_active=true;
            await lockDb();
            await deleteFromDb("Delete From building");
            await deleteFromDb("Delete From floor");
            await deleteFromDb("Delete From device");
            await deleteFromDb("Delete From preference Where key!='max_room_id' And key!='first_run'");
            await updateToDb("Update preference set value='1' Where key='max_room_id'");
            await deleteFromDb("Delete from workingtime");
            await deleteFromDb("Delete From room");
            await deleteFromDb("Delete From updatetime");
            await insertToDb('Insert Into room (floor_id, name, id) Values (1, "Conference Room", 1)');
            await insertToDb('Insert Into floor Values (1, "", 1)');
            await insertToDb('Insert Into workingtime Values (1, "monday", 59, 1, 0, 0, 23), (1, "tuesday", 59, 2, 0, 0, 23), (1, "wednesday", 59, 3, 0, 0, 23), (1, "thursday", 59, 4, 0, 0, 23), (1, "friday", 59, 5, 0, 0, 23), (1, "saturday", 59, 6, 0, 0, 23), (1, "sunday", 59, 7, 0, 0, 23)');
            await unlockDb();
            sync_active=false;
            if(write_resp==true)
            {
                var result=await getAllDataFromDb();
                mainWindow.webContents.send("data_sync",result);
                writeResultToResponse(responze,{msg:true});
            }
        }
        else
        {   
            setTimeout(async function()
            {   
                await clearAdminDb(responze,write_resp);
            },500);
           /* if(write_resp==true)
            {
                writeResultToResponse(responze,{msg:false});
            }*/
           
        }   
   
}
async function checkDevicesPreferenceExist()
{
    if( await checkDbLocked()==false)
    {
        var devices=await selectFromDb("Select id from device");
        for(var i=0;i<devices.length;i++)
        {
            var preference=await selectFromDb("Select device_id from preference Where device_id='"+devices[i].id+"'");
            if(preference.length==0 || preference.length==1 || preference.length==2)
            {
                await deleteFromDb("Delete From device Where id='"+devices[i].id+"'");
                await deleteFromDb("Delete From preference Where device_id='"+devices[i].id+"'");
            }
        }
    }
    
}
async function copyDbToUserDir()
{
    if (!fs.existsSync(file)) 
    {   
        ensureDirectoryExistence(file)
        fs_extra.copySync(tmp_file, file);
    }
    var db_version=fs.readFileSync(db_version_file, "utf8");
    if(db_version.length>0)
    {   
        db_version=JSON.parse(db_version);
        var result=await selectFromDb("SELECT tbl_name as name FROM sqlite_master Where tbl_name='db_version'");
        if(result.length==0)
        {
            await insertToDb("CREATE TABLE 'db_version' ('db_version' INTEGER)");
        }
        for(var i=0;i<db_version.length;i++)
        {
            result=await selectFromDb("Select db_version from db_version");

            if(result.length==0 || parseInt(result[0].db_version)<parseInt(db_version[i].version))
            {
                var script_file=path.join(electron.app.getAppPath(), 'backend', 'database','scripts',db_version[i].script_file);
                var db_script=fs.readFileSync(script_file, "utf8");
                if(db_script.length>0)
                {
                    db_script=JSON.parse(db_script);
                    for(var j=0;j<db_script.length;j++)
                    {
                        try
                        {
                            await insertToDb(db_script[j].command);
                        }
                        catch(ex){}
                    }
                }
                await deleteFromDb("Delete From db_version");
                await insertToDb("Insert into db_version(db_version) Values ('"+db_version[i].version+"')");
            }      
        }
    }
}
function ensureDirectoryExistence(filePath) {
    var dirname = path.dirname(filePath);
    if (fs.existsSync(dirname)) {
      return true;
    }
    ensureDirectoryExistence(dirname);
    fs.mkdirSync(dirname);
  }
function initDb()
{
    try
    {
        db=new sqlite3.Database(file);
        /*db.run("PRAGMA KEY = 'test'");
        db.run("PRAGMA CIPHER = 'aes-128-cbc'");*/
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 114","Error");
        throw ex;
    }
   
}
function closeDb()
{
    try
    {
        if(db!=null)
        {
            db.close((err) => { });
            db=null;
        }  
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 131","Error");
        throw ex;
    }
    
}
function findUpdateTime(device_updatetimes,table_name)
{
    for(var time_key in device_updatetimes)
    {
        if(time_key==table_name)
        {
            return parseInt(device_updatetimes[time_key]);
        }
    }
}
async function checkSynced(meta)
{
    if(meta.db_last_update==0)
    {
        return false;
    }
    else if(meta.db_last_update>0)
    {
        var sql="Select * from updatetime Where table_name='preference'";
        var result=[];
        if(await checkDbLocked()==false)
        {
            result=await selectFromDb(sql);
        }
        else
        {
            return true;
        }
        if(result.length==0)
        {   
            return false;
        }
        else if(parseInt(result[0].time)<meta.db_last_update || parseInt(result[0].time)==0)
        {
            return false;
        }
    }

    return true;
}
async function checkUpdateTime(device_updatetimes,table_name)
{   
    var result=[];
    var time=findUpdateTime(device_updatetimes,table_name);
    
    var sql="Select * from updatetime Where table_name='"+table_name+"'";

    if(await checkDbLocked()==false)
    {
        result=await selectFromDb(sql);
    }
    else
    {
        return false;
    }
    if(result.length==0)
    {   
        return true;
    }
    else if(parseInt(result[0].time)<time || parseInt(result[0].time)==0)
    {
        return true;
    }
    else
    {
        return false;
    }
}
async function modifyUpdateTime(device)
{
    for(var table_name in device)
    {
        if(table_name!="meta")
        {
            if(await checkUpdateTime(device["updatetime"],table_name)==true)
                {
                    var time=findUpdateTime(device["updatetime"],table_name);
                    if(time==0)
                    {
                        time=Math.round(+new Date());
                    }
                    if(time)
                    {
                        await deleteFromDb("Delete from updatetime Where table_name='"+table_name+"'");
                        await insertToDb("Insert into updatetime(time,table_name) Values('"+time+"','"+table_name+"')");
                    }
                            
                }
        }
       
    }
  
}
async function updateDeviceStatus(device,ipc=true)
{
    if(device==null)
    {
        await updateToDb("Update device set status='0'");
    }
    else
    {
        await updateToDb("Update device set status='1' Where ip_address='"+device+"'");
    }
    if(ipc==true)
    {
        mainWindow.webContents.send("status_update",await selectFromDb("Select id,status from device"));
    }
    return true;
}
function checkDeviceState(devices,index)
{
    http.get("http://"+devices[index].ip_address+":8080/get_info?overview_sync_enabled=true",{ timeout: 10000 }, (error, response, body) => 
    {
        if (error || response.statusCode == 500 || response.statusCode == 404) 
        {
            devices[index].status=0;
            checkDeviceStateEnd(devices,index);
        }
        else if (response && body) 
        {
            devices[index].status=1;
            checkDeviceStateEnd(devices,index);
        }
    });
}
async function checkDeviceStateEnd(devices,index)
{
    index++;
    if(index<devices.length)
    {
        checkDeviceState(devices,index);
    }
    else
    {
         await updateDeviceStatus(null,false);
         for(var i=0;i<devices.length;i++)
         {
            if(devices[i].status==1)
            {
                await updateDeviceStatus(devices[i].ip_address,false);
            }
           
         }
         mainWindow.webContents.send("status_update",await selectFromDb("Select id,status from device"));
    }
}
async function modifyDeviceDataFromTablet(device,new_data_action)
{
    for(var table_name in device)
    {
        if(await checkDbLocked()==false)
        {
            if(table_name!="language" && table_name!="reservation" && table_name!="updatetime" && table_name!="meta" )
            {   
                for(var i=0;i<device[table_name].length;i++)
                {
                    var data_for_insert=device[table_name][i];
                    new_data_action=await modifyDataFromTablet(data_for_insert,table_name,device["updatetime"],new_data_action,device["meta"]);
                }
        
            }
        }
        
        
    }
    return new_data_action;
}
async function modifyDataFromTablet(table_data,table_name,device_updatetimes,new_data_action,meta)
{
    if(await checkDbLocked()==false)
    {
        var select_sql="Select * from "+table_name+" where ";
        if(table_name=="preference")
            select_sql+="device_id='"+table_data["device_id"]+"' AND key='"+table_data["key"]+"'";
        else if(table_name=="workingtime")
            select_sql+="room_id='"+table_data["room_id"]+"' AND id='"+table_data["id"]+"'";
        else
            select_sql+="id='"+table_data["id"]+"'";
        if(await checkDbLocked()==false)
        {
            var result=await selectFromDb(select_sql);
            if(result.length==0)
            {
                if(await checkDbLocked()==false)
                {
                    if(table_name=="workingtime" || table_name=="room" || table_name=="preference" || table_name=="floor" || table_name=="building")
                    {
                        if(await checkUpdateTime(device_updatetimes,table_name)==true)
                        {
                            await insertDataFromTablet(table_data,table_name);
                            new_data_action=true;
                        }
                        else if(await checkSynced(meta)==false)
                        {
                            await insertDataFromTablet(table_data,table_name);
                            new_data_action=true;
                        }
                    }
                    else
                    {
                        await insertDataFromTablet(table_data,table_name);
                        new_data_action=true;
                    }
                   
                }
            }
            else
            {
                if(await checkUpdateTime(device_updatetimes,table_name)==true)
                {
                    if(await checkDbLocked()==false)
                    {
                        await updateDataFromTablet(table_data,table_name);
                        new_data_action=true;
                    }
                    
                }
                   
            }
        }
       
    }
    return new_data_action;
}
async function updateDataFromTablet(table_data,table_name)
{
    var sql_statement={sql:"Update "+table_name+" Set ",values:""};
    var exist_column_names= await getColumnNamesFromTable(table_name);
    for(var column_key in table_data)
    {
        if(exist_column_names.indexOf(column_key)!=-1)
        {
            if(table_name=="room")
            {
                if(column_key!="working_time" && column_key!="reservations" && column_key!="floor_name")
                {
                    sql_statement.values+=column_key+"='"+table_data[column_key].toString().replace(/'/g, "''")+"',";
                }
            }
            else if(table_name=="floor")
            {
                if(column_key!="rooms")
                {
                    sql_statement.values+=column_key+"='"+table_data[column_key].toString().replace(/'/g, "''")+"',";
                }
            }
            else
            {
                sql_statement.values+=column_key+"='"+table_data[column_key].toString().replace(/'/g, "''")+"',";
            }
        }
    }
    if(sql_statement.values.length>0)
    {
        sql_statement.values=sql_statement.values.substr(0, sql_statement.values.length - 1);
        sql_statement.sql+=sql_statement.values+" Where ";
        if(table_name=="preference")
        {
            sql_statement.sql+="device_id='"+table_data["device_id"]+"' And key='"+table_data["key"]+"'";
        }
        else if(table_name=="workingtime")
            sql_statement.sql+="room_id='"+table_data["room_id"]+"' AND id='"+table_data["id"]+"'";
        else
        {
            sql_statement.sql+="id='"+table_data["id"]+"'";
        }
        transactions.push(sql_statement.sql);
        /*if(await checkDbLocked()==false)
        {
            await updateToDb(sql_statement.sql);
        }*/
    }
   
    
}
async function getColumnNamesFromTable(table_name)
{
    var columns=[];
    var table=await selectFromDb("SELECT name FROM sqlite_master Where name='"+table_name+"'");
    if(table.length==0)
    {
        return columns;
    }
    var result=await selectFromDb("PRAGMA table_info("+table_name+")");
    for(var i=0;i<result.length;i++)
    {
        columns.push(result[i].name);
    }
    return columns;
}
async function insertDataFromTablet(table_data,table_name)
{
    var sql_statement={sql:"Insert into "+table_name,columns:"",values:""};
    var exist_column_names= await getColumnNamesFromTable(table_name);
    for(var column_key in table_data)
    {
        if(exist_column_names.indexOf(column_key)!=-1)
        {
            if(table_name=="room")
            {
                if(column_key!="working_time" && column_key!="reservations" && column_key!="floor_name")
                {
                    sql_statement.columns+=column_key+",";
                    sql_statement.values+="'"+table_data[column_key].toString().replace(/'/g, "''")+"',";
                }
            }
            else if(table_name=="floor")
            {
                if(column_key!="rooms")
                {
                    sql_statement.columns+=column_key+",";
                    sql_statement.values+="'"+table_data[column_key].toString().replace(/'/g, "''")+"',";
                }
            }
            else if(table_name=="workingtime")
            {
                sql_statement.columns+=column_key+",";
                sql_statement.values+="'"+table_data[column_key].toString().replace(/'/g, "''")+"',";
            }
            else
            {
                sql_statement.columns+=column_key+",";
                sql_statement.values+="'"+table_data[column_key].toString().replace(/'/g, "''")+"',";
            }
        }
    }
    if(sql_statement.values.length>0 && sql_statement.columns.length>0)
    {
        sql_statement.values=sql_statement.values.substr(0, sql_statement.values.length - 1);
        sql_statement.columns=sql_statement.columns.substr(0, sql_statement.columns.length - 1);
        sql_statement.sql+=" ("+sql_statement.columns+") Values ("+sql_statement.values+")";
        transactions.push(sql_statement.sql);
        /*if(await checkDbLocked()==false)
        {
            await insertToDb(sql_statement.sql);
        }*/
    }
   
   
}

async function insertAllDataToDb(params,clear_up=false)
{
    var sqls_for_transaction=[];
    try
    {
        for(var table_name in params)
        {
            if(blocked_tables.for_post.indexOf(table_name)==-1)
            {
                if(clear_up==true)
                {
                    sqls_for_transaction.push("Delete From "+table_name);
                }
                var tmp_sql=await insertDataFromAdmin(table_name,params[table_name]);
                if(tmp_sql)
                {
                    for(var i=0;i<tmp_sql.length;i++)
                    {
                        sqls_for_transaction.push(tmp_sql[i]);
                    }
                }
                if(params["preference"].length>2)
                {
                    sqls_for_transaction.push("Delete From updatetime Where table_name='"+table_name+"'");
                    sqls_for_transaction.push("Insert into updatetime (time,table_name) Values ('"+Math.round(+new Date()).toString()+"','"+table_name+"')");
                }
                
            }
        }
        await runTransaction(sqls_for_transaction);
        return params;
    }
    catch(ex)
    {
       EventLog.writeLog(JSON.stringify(ex),"Error",353);
       throw ex;
    }
    
}
async function getAllDataFromDb()
{
    try
    {
        var result={};
        var db_tables=await selectFromDb("SELECT tbl_name as name FROM sqlite_master Where tbl_name not in("+blocked_tables.for_get+")");
        for (var key in db_tables) 
        {
            if(db_tables[key].name!="db_lock" && db_tables[key].name!="db_version")
            {
                result[db_tables[key].name]=await selectFromDb("Select * From "+db_tables[key].name);
            }
           
        }
        return result;
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 372","Error");
        throw ex;
    }
    return null;
   
}
async function insertDataFromAdmin(table_name,table)
{
    try
    {
       
        var insert_sqls=[];
        if(table.length==0)
        {
            return null;
        }
        for(var row_num in table)
        {
            var sql_statement={insert:"Insert into "+table_name,columns:"",values:""};
            var row=table[row_num];
            if(sql_statement.columns=="")
            {
                 for(var key in row)
                 {
                     sql_statement.columns+=key+",";
                     if(row[key]==null)
                     {
                        sql_statement.values+=row[key]+",";
                     }
                     else
                     {
                        sql_statement.values+="'"+row[key].toString().replace(/'/g, "''")+"',";
                     }
                 }
            }
            sql_statement.columns = sql_statement.columns.substr(0, sql_statement.columns.length - 1);
            sql_statement.values = sql_statement.values.substr(0, sql_statement.values.length - 1);
            sql_statement.insert+="("+sql_statement.columns+") Values ("+sql_statement.values+")";
            insert_sqls.push(sql_statement.insert);
        }
        return insert_sqls;
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 414","Error");
        throw ex;
    }
  
}
async function runTransaction(sqls)
{
    try
    {
        return new Promise(function(resolve, reject)
        {
            try
            {
                initDb();
                db.configure("busyTimeout", 60000);
                if(!sqls)
                {
                    closeDb()
                    resolve(null);
                }
                db.serialize(function()
                {
                    try
                    {
                        db.run('BEGIN;');
                        for(var i=0;i<sqls.length;i++)
                        {
                            db.run(sqls[i]);
                        }
                        db.run("COMMIT;",function (err, rows) 
                        {
                            if (err) 
                            {
                                closeDb();
                                reject(err);
                            }
                            closeDb();
                            resolve(null);
                        });
                        
                    }
                    catch(ex)
                    {
                        EventLog.writeLog(JSON.stringify(ex)+" LINE 540","Error");
                        closeDb();
                        resolve(null);
                    }
                    
                });
            }
            catch(ex)
            {
                EventLog.writeLog(JSON.stringify(ex)+" LINE 548","Error");
                closeDb();
                resolve(null);
            }
            

        });
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 557","Error");
    }
}
function selectFromDb(sql)
{
    try
    {
        return new Promise(function(resolve, reject) 
        {
            var result=[];
            try
            {
                initDb();
                db.configure("busyTimeout", 60000);
                if(!sql)
                {
                    closeDb()
                    resolve(result);
                }
                db.all(sql, function (err, rows) 
                {
                    try
                    {
                        if (err) 
                        {
                            closeDb();
                            reject(err);
                        }
                        rows.forEach(function (row) 
                        {
                            try
                            {
                                result.push(row);
                            }
                            catch(ex)
                            {
                                EventLog.writeLog(JSON.stringify(ex)+" LINE 451","Error");
                                closeDb();
                                resolve(ex);
                            }
                        });
                        closeDb();  
                        resolve(result);    
                    }
                    catch(ex)
                    {
                        EventLog.writeLog(JSON.stringify(ex)+" LINE 461","Error");
                        closeDb();
                        resolve(ex);
                    }
                   
                    
                });
            }
            catch(ex)
            {
                EventLog.writeLog(JSON.stringify(ex)+" LINE 471","Error");
                closeDb();
                resolve(ex);
            }
        });  
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 479","Error");
    }
    
}
async function insertToDb(sql)
{
    try
    {
        return new Promise(function(resolve, reject) 
        {
            try
            {
                initDb();
                db.configure("busyTimeout", 60000);
                var result=[];
                if(!sql)
                {
                    closeDb();
                    resolve(result);
                }
                db.run(sql, function (err, rows) 
                {
                    try
                    {
                        if (err) 
                        {
                            closeDb();
                            reject(err);
                        }
                        closeDb();  
                        resolve(result);
                    }
                    catch(ex)
                    {
                        EventLog.writeLog(JSON.stringify(ex)+" LINE 513","Error");
                        closeDb();
                        resolve(ex);
                    }
                   
                    
                });
            }
            catch(ex)
            {
                EventLog.writeLog(JSON.stringify(ex)+" LINE 523","Error");
                closeDb();
                resolve(ex);
            }
        });
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 531","Error");
        resolve(ex);
    }
    
}
async function deleteFromDb(sql)
{
    try
    {
        return new Promise(function(resolve, reject) 
        {
            var result=[];
            try
            {
                initDb();
                db.configure("busyTimeout", 60000);
                if(!sql)
                {
                    closeDb();
                    resolve(result);
                }
                db.run(sql, function (err, rows) 
                {
                    try
                    {
                        if (err) 
                        {
                            closeDb();
                            reject(err);
                        }
                        closeDb();  
                        resolve(result);
                    }
                    catch(ex)
                    {
                        EventLog.writeLog(JSON.stringify(ex)+" LINE 565","Error");
                        closeDb();
                        resolve(ex);
                    } 
                });
            }
            catch(ex)
            {
                EventLog.writeLog(JSON.stringify(ex)+" LINE 573","Error");
                closeDb();
                resolve(ex);
            }
        });
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 581","Error");
        resolve(ex);
    }
}
async function updateToDb(sql)
{
    try
    {
        return new Promise(function(resolve, reject) 
        {
            var result=[];
            try
            {
                initDb();
                db.configure("busyTimeout", 60000);
                if(!sql)
                {
                    closeDb();
                    resolve(result);
                }
                db.run(sql, function (err, rows) 
                {
                    try
                    {
                        if (err) 
                        {
                            closeDb();
                            reject(err);
                        }
                        closeDb();  
                        resolve(result);
                    }
                    catch(ex)
                    {
                        EventLog.writeLog(JSON.stringify(ex)+" LINE 614","Error");
                        closeDb();
                        resolve(ex);
                    } 
                });
            }
            catch(ex)
            {
                EventLog.writeLog(JSON.stringify(ex)+" LINE 622","Error");
                closeDb();
                resolve(ex);
            }
        });
    }
    catch(ex)
    {
        EventLog.writeLog(JSON.stringify(ex)+" LINE 630","Error");
        resolve(ex);
    }
}
async function lockDb()
{
    await updateToDb("Update db_lock set lock='1'");
    db_locked=true;
}
async function unlockDb()
{
    await updateToDb("Update db_lock set lock='0'");
    db_locked=false;
}
async function checkDbLocked()
{
   /* var lock=await selectFromDb("Select * From db_lock Where lock='1'");
    if(lock.length==0)
    {
        return false;
    }
    return true;*/
    return db_locked;
}
function writeResultToResponse(responze, result) 
{
    responze.end(JSON.stringify(result));
}