const path = require('path');
const EventLog= require(path.join(__dirname, 'EventLog.js'));
const EWS = require('node-ews');
const NTLMAuth = require('httpntlm').ntlm;
var rooms={};
module.exports=
{
  configMsCalendar:function(responze,params)
    {
        rooms={};
        var config=null;
        var ewsSoapHeader={};
        const options = 
        {
          strictSSL: false
        };
        process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';
        const ntHashedPassword = NTLMAuth.create_NT_hashed_password(params.password);
        const lmHashedPassword = NTLMAuth.create_LM_hashed_password(params.password);
        if(params.host)
        {
           // config={username: params.username,nt_password: ntHashedPassword,lm_password: lmHashedPassword,host:params.host};
           config={username: params.username,password:params.password,host:params.host};
           ewsSoapHeader={'t:RequestServerVersion': {attributes: {Version: params.exchange_version}}};
        }
        else
        {
           config={username: params.username,password:params.password,host:"https://outlook.office365.com",auth:"basic"};
           // config={username: params.username,nt_password: ntHashedPassword,lm_password: lmHashedPassword,host:"https://outlook.office365.com"};
        }
         
        const ewsConfig = config;
        const ews = new EWS(ewsConfig,options); 
        checkAuth(ews,null,params.username,responze,ewsSoapHeader)
    }
}
function checkAuth(ews,args,user,responze,ewsSoapHeader)
{
  
  // define ews api function args
  const ewsArgs = {
    'Mailbox': {
      'EmailAddress':user
    }
  };
  ews.run('ExpandDL', ewsArgs,ewsSoapHeader)
  .then(result => {
    getRoomGroups(ews,null,responze,ewsSoapHeader);
    
  })
  .catch(err => {
    EventLog.writeLog(err.message,"Error");
    writeResultToResponse(responze, {login:false});
  });
  
}
function getRoomGroups(ews,args,responze,ewsSoapHeader)
{
  ews.run("GetRoomLists", {},ewsSoapHeader)
  .then(result => {
    if(result.RoomLists)
    { 
      if(Array.isArray(result.RoomLists.Address))
      {
        getRooms(ews,result,responze,ewsSoapHeader,0);
      }
      else
      {
        getRooms(ews,result,responze,ewsSoapHeader,null);
      }
     
    }
    else
    {
      writeResultToResponse(responze, {rooms:false})
    }
    
  })
  .catch(err => {
    EventLog.writeLog(err.message,"Error");
    writeResultToResponse(responze, {login:false});
  });
}
function getRooms(ews,args,responze,ewsSoapHeader,index=null)
{
  var get_rooms_param={};
  if(index!=null)
  {
    get_rooms_param={RoomList:args.RoomLists.Address[index]};
  }
  else
  {
    get_rooms_param={RoomList:args.RoomLists.Address};
  }
  ews.run("GetRooms", get_rooms_param,ewsSoapHeader)
  .then(result => {
    if(result.Rooms)
    {
      if(index==null)
      {
        rooms[args.RoomLists.Address.Name]=[];
      }
      else
      {
        rooms[args.RoomLists.Address[index].Name]=[];
      }
      if(Array.isArray(result.Rooms.Room))
      {
        if(index==null)
        {
          for(var i=0;i<result.Rooms.Room.length;i++)
          {
            rooms[args.RoomLists.Address.Name].push({name:result.Rooms.Room[i].Id.Name,id:result.Rooms.Room[i].Id.EmailAddress,group:args.RoomLists.Address.Name,group_id:args.RoomLists.Address.EmailAddress})
          }
        }
        else
        {
          for(var i=0;i<result.Rooms.Room.length;i++)
          {
            rooms[args.RoomLists.Address[index].Name].push({name:result.Rooms.Room[i].Id.Name,id:result.Rooms.Room[i].Id.EmailAddress,group:args.RoomLists.Address[index].Name,group_id:args.RoomLists.Address[index].EmailAddress})
          }
        }
      }
      else
      {
        if(index==null)
        {
          rooms[args.RoomLists.Address.Name].push({name:result.Rooms.Room.Id.Name,id:result.Rooms.Room.Id.EmailAddress,group:args.RoomLists.Address.Name,group_id:args.RoomLists.Address.EmailAddress})
        }
        else
        {
          
          rooms[args.RoomLists.Address[index].Name].push({name:result.Rooms.Room.Id.Name,id:result.Rooms.Room.Id.EmailAddress,group:args.RoomLists.Address[index].Name,group_id:args.RoomLists.Address[index].EmailAddress})
        }
      }
      
    }
    checkGetRoomsEnd(ews,args,responze,index,ewsSoapHeader);
  })
  .catch(err => {
    EventLog.writeLog(err.message,"Error");
    writeResultToResponse(responze, {login:false});
  });
}
function checkGetRoomsEnd(ews,args,responze,index,ewsSoapHeader)
{
  if(index==null)
  {
    writeResultToResponse(responze, rooms);
    return;
  }
  index++;
  if(index==args.RoomLists.Address.length)
  {
    writeResultToResponse(responze, rooms);
  }
  else
  {
    getRooms(ews,args,responze,ewsSoapHeader,index)
  }
 
}
function writeResultToResponse(responze, result) 
{
    responze.end(JSON.stringify(result));
}